/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.locojoy.base.Marshal.Marshal
 *  com.locojoy.base.Marshal.OctetsStream
 *  com.locojoy.base.Octets
 *  fire.pb.util.OctetsUtil
 *  mkdb.Bean
 *  mkdb.Mkdb
 *  mkdb.TTable
 */
package fire.pb.cross;

import com.locojoy.base.Marshal.Marshal;
import com.locojoy.base.Marshal.OctetsStream;
import com.locojoy.base.Octets;
import fire.pb.cross.CrossManager;
import fire.pb.cross.TableData;
import fire.pb.util.OctetsUtil;
import java.lang.reflect.Method;
import mkdb.Bean;
import mkdb.Mkdb;
import mkdb.TTable;

public class TransferDataManager {
    private static final String[] STANDARD_TYPE_ARRAY = new String[]{"short", "int", "long", "float", "boolean", "string", "binary", "set", "list", "vector", "map", "treemap"};

    public static TransferDataManager getInstance() {
        return SingletonHolder.singleton;
    }

    private TransferDataManager() {
    }

    public Octets getTableData(String tableName, String beanName, Object tableKey) {
        TTable table = (TTable)Mkdb.getInstance().getTables().getTable(tableName);
        if (table == null) {
            return null;
        }
        Object data = table.get(tableKey);
        if (data == null) {
            return null;
        }
        if (!this.isStandardType(beanName)) {
            OctetsStream os = new OctetsStream();
            Bean bean = (Bean)data;
            return os.marshal((Marshal)bean);
        }
        return this.getStandDardOctets(beanName, data);
    }

    private Octets getStandDardOctets(String beanName, Object data) {
        if (data == null) {
            return null;
        }
        OctetsStream os = new OctetsStream();
        if (beanName.equals("boolean")) {
            return os.marshal(((Boolean)data).booleanValue());
        }
        if (beanName.equals("short")) {
            return os.marshal(((Short)data).shortValue());
        }
        if (beanName.equals("int")) {
            return os.marshal(((Integer)data).intValue());
        }
        if (beanName.equals("long")) {
            return os.marshal(((Long)data).longValue());
        }
        if (beanName.equals("float")) {
            return os.marshal(((Float)data).floatValue());
        }
        if (beanName.equals("string")) {
            return os.marshal((String)data);
        }
        throw new RuntimeException("不支持的转换类型。type=" + beanName);
    }

    public TableData genTableData(String tableName, long tableKey, Bean tableValue) {
        TableData tableData = new TableData();
        tableData.tablename = tableName;
        tableData.keydata = OctetsUtil.toOctets((long)tableKey);
        tableData.valuedata = new OctetsStream().marshal((Marshal)tableValue);
        return tableData;
    }

    public void setTableData(String tableName, String keyType, String valueType, Octets keyData, Octets valueData) throws Exception {
        TTable table = (TTable)Mkdb.getInstance().getTables().getTable(tableName);
        if (table == null) {
            return;
        }
        Object tableKey = this.getOriginalDataByType(keyType, keyData);
        table.remove(tableKey);
        Object tableValue = this.getOriginalDataByType(valueType, valueData);
        table.insertUncheckedAutoKey(tableKey, tableValue);
    }

    private Object getOriginalDataByType(String type, Octets octets) throws Exception {
        OctetsStream os = new OctetsStream(octets);
        if (!this.isStandardType(type)) {
            Class<?> cls = Class.forName("xbean.Pod");
            Method method = cls.getDeclaredMethod("new" + type, new Class[0]);
            Bean bean = (Bean)method.invoke(cls, new Object[0]);
            bean.unmarshal(os);
            return bean;
        }
        Object object = null;
        if (type.equals("boolean")) {
            object = os.unmarshal_boolean();
        } else if (type.equals("short")) {
            object = os.unmarshal_short();
        } else if (type.equals("int")) {
            object = os.unmarshal_int();
        } else if (type.equals("long")) {
            object = os.unmarshal_long();
        } else if (type.equals("float")) {
            object = Float.valueOf(os.unmarshal_float());
        } else if (type.equals("string")) {
            object = os.unmarshal_String();
        } else {
            throw new RuntimeException("不支持的转换类型。type=" + type);
        }
        return object;
    }

    private boolean isStandardType(String typeStr) {
        if (typeStr == null || typeStr.trim().equals("")) {
            return false;
        }
        for (String str : STANDARD_TYPE_ARRAY) {
            if (!typeStr.trim().equals(str)) continue;
            return true;
        }
        return false;
    }

    public void setTableDataSrcServer(String tableName, String keyType, String valueType, Octets keyData, Octets valueData) throws Exception {
        if (CrossManager.getInstance().isInCrossServer()) {
            CrossManager.logger.error((Object)"Exception:原服务器调用TransferDataManager.setTableDataSrcServer方法");
            return;
        }
        if (!this.checkModifySrcServer(tableName)) {
            CrossManager.logger.error((Object)"Exception:原服务器 setTableDataSrcServer.setTableDataSrcServer方法");
            return;
        }
        TTable table = (TTable)Mkdb.getInstance().getTables().getTable(tableName);
        if (table == null) {
            CrossManager.logger.error((Object)"Exception:原服TransferDataManager.setTableDataSrcServer方法  table=null");
            return;
        }
        Object tableKey = this.getOriginalDataByType(keyType, keyData);
        table.remove(tableKey);
        Object tableValue = this.getOriginalDataByType(valueType, valueData);
        table.insertUncheckedAutoKey(tableKey, tableValue);
    }

    public boolean checkModifySrcServer(String tableName) {
        return tableName.equals("hslj") || tableName.equals("crossmatrix") || tableName.equals("hsljteams");
    }

    static class SingletonHolder {
        static TransferDataManager singleton = new TransferDataManager();

        SingletonHolder() {
        }
    }
}

